/* Mathematik C fuer Informatikstudierende -- Serie 7 -- 15.12.2013
   Anna Schleimer, Thure Duehrsen
   Aufgabe 7.3: Vektoriteration
*/


#ifndef MY_HEADER_MATRIX

#define MY_HEADER_MATRIX

#include "Tuple.h"
#include "Vector.h"

typedef enum tmp_MatrixOrdering { ROWWISE, COLUMNWISE } MatrixOrdering;

struct tmp_MatrixOfDouble {
    
  unsigned int   numberOfRows;    /* Anzahl der Zeilen,  > 0 */
  unsigned int   numberOfColumns; /* Anzahl der Spalten, > 0 */
  TupleOfDouble  values;          /* Eintraege der Matrix */
  MatrixOrdering ordering;        /* Zeilen- oder spaltenweise
				     Anordnung der Elemente im
				     Speicher */
};

typedef struct tmp_MatrixOfDouble MatrixOfDouble; 

MatrixOfDouble   MatrixOfDouble_Create  (unsigned int,
                                         unsigned int,
					 MatrixOrdering); 
                                       
void             MatrixOfDouble_CopyValues  (MatrixOfDouble, MatrixOfDouble);

MatrixOfDouble   MatrixOfDouble_Copy (MatrixOfDouble);

void             MatrixOfDouble_Destroy (MatrixOfDouble*);

MatrixOfDouble   MatrixOfDouble_LoadFromFile (char*);

void             MatrixOfDouble_Print (MatrixOfDouble);

MatrixOrdering   MatrixOfDouble_getOrdering (MatrixOfDouble);

void             MatrixOfDouble_setOrdering (MatrixOfDouble, MatrixOrdering);

double           MatrixOfDouble_GetEntry_0 (MatrixOfDouble,
                                            unsigned int,
                                            unsigned int);

double           MatrixOfDouble_GetEntry_1 (MatrixOfDouble,
                                            unsigned int,
                                            unsigned int);

void             MatrixOfDouble_SetEntry_0 (MatrixOfDouble,
                                            unsigned int,
                                            unsigned int,
                                            double);          /* neu */

void             MatrixOfDouble_SetEntry_1 (MatrixOfDouble,
                                            unsigned int,
                                            unsigned int,
                                            double);

void             MatrixOfDouble_Add_inPlace (MatrixOfDouble,
					     MatrixOfDouble); /* neu */

void             MatrixOfDouble_Sub_inPlace (MatrixOfDouble,
					     MatrixOfDouble); /* neu */

void             MatrixVectorMult_inPlace (VectorOfDouble,
                                           MatrixOfDouble,
                                           VectorOfDouble);

VectorOfDouble   MatrixVectorMult (MatrixOfDouble, VectorOfDouble);

void             VectorIteration (MatrixOfDouble,
				  VectorOfDouble*,
				  unsigned int);

void             NormalisedVectorIteration (MatrixOfDouble,
					    VectorOfDouble*,
					    unsigned int);


#endif
