/* Mathematik C fuer Informatikstudierende -- Serie 7 -- 15.12.2013
   Anna Schleimer, Thure Duehrsen
   Aufgabe 7.3: Vektoriteration
*/


#include <stdlib.h>
#include <stdio.h>
#include "Tuple.h"

TupleOfDouble TupleOfDouble_Create  (unsigned int n) {

  /* Bekommt eine natuerliche Zahl n uebergeben, fordert ausreichend
     Speicher an, um n Double-Werte zusammenhaengend aufzunehmen,
     initialisiert alle Komponenten mit -1, und gibt bei Erfolg die
     Adresse zurueck, an dem der Speicherblock beginnt, bei Misserfolg
     wird ein NULL-Zeiger zurueckgegeben.     
  */

  TupleOfDouble tuple = NULL;
  unsigned int i;

  if (n == 0) {

    fprintf (stderr, "Invalid initialiser: Tuple without components\n");
    return NULL;

  }

  tuple = (TupleOfDouble) malloc(n * sizeof (double));

  if (tuple == NULL) {

    fprintf (stderr, "Unable to create tuple\n");
    return NULL;
  }

  for (i = 0; i < n; i++) tuple[i] = -1;

  return tuple;

}

void          TupleOfDouble_Destroy (TupleOfDouble t) {

  /* Gibt den Speicher wieder frei, den das Tupel t belegt.
   */

  free (t);

}

/* hier kommen spater noch andere Arten von Tupeln hin, z.B. Tupel
   rationaler Zahlen
 */
